//texture
float Contrast =1;
float OFFER = 0.5;
//	  /*
float Frequency = 10;
float Phase = 0;
float Amplitude = 0.1;
//	  */


texture Tex <string uiname="Texture";>;
sampler Samp = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
	AddressW = WRAP;
	

	
};
//the data structure: "vertexshader to pixelshader"
//used as output data with the VS function
//and as input data with the PS function 
struct vs2ps
{
    float4 Pos  : POSITION;
    float2 TexCd : TEXCOORD0;
};
// --------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// --------------------------------------------------------------------------------------------------

/*vs2ps VS(
    float4 PosO  : POSITION,
    float4 TexCd : TEXCOORD0)
{
    //declare output struct
    vs2ps Out;
 
    //offset x coordinate
    PosO.x += sin(PosO.y * Frequency + Phase) * Amplitude;
 
    //transform position
    Out.Pos = mul(PosO, tWVP);
 
    //transform texturecoordinates
    Out.TexCd = mul(TexCd, tTex);
 
    return Out;
}
*/



// --------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// --------------------------------------------------------------------------------------------------
float4 ConvertToGray(float4 col)
{
    const float4 lumcoeff = {0.3, 0.59, 0.11, 0};
    return dot(col, lumcoeff);
} 

float4 Ggg(vs2ps In): COLOR
{
	// /*
	//common look
	return tex2D(Samp, In.TexCd);
	// */
	
	/*
	// only red 
    return float4(1,0,0.2,0.3);
	*/
	
	/*
	//contrast
	float4 col = tex2D(Samp, In.TexCd);
	col.rgb -= 0.5;
	col.rgb *= Contrast;
	col.rgb += 0.5;
	return col;
	*/
	
	/*
	//free channel
	float4 col = tex2D(Samp, In.TexCd);
	return col.bgra ;
	*/
	
	/*
	// black&white
	float4 col = tex2D(Samp, In.TexCd);
	return ConvertToGray(col);
	*/
	
	 /*
	//mirror
	float2 cord = In.TexCd;
	cord.x += OFFER;
	cord.y += OFFER;
	return tex2D(Samp, cord);
	 */
	
	 /*
	//TexCd U&V
	return float4 (In.TexCd, OFFER, 1);
	 */
	
	  /*
	//Texture Ripple
    float2 cord = In.TexCd;
    cord.x += sin(cord.y * Frequency + Phase) * Amplitude;
    float4 col = tex2D(Samp, cord);
    return col;
	  */
	
	  /*
	//Texture Ripple
	float2 cord = In.TexCd - 0.5;
    float dist = sqrt(pow(cord.x, 2) + pow(cord.y, 2));
    float4 col = sin(dist * Frequency + Phase) * Amplitude;
	 //float4 col= tex2D(Samp, cord);
    col.a = 1;  //make sure the alpha component is 1
    return col;
	  */

}
 
technique TSimpleShader
{
    pass P0
    {
        VertexShader = null;
        PixelShader  = compile ps_2_0 Ggg();
    }
}